\documentclass{report}

\usepackage{common/uruwi}

\makeglossaries


\newglossaryentry{battle}{
  name=battle,
  description={A system with two \glspl{team}, where a team's objective is to \gls{defeat} all members of the other team}
}
\newglossaryentry{match}{
  name=match,
  plural=matches,
  description={A battle in \acrfull{pvp} combat. Also to place \glspl{player} into a match}
}
\newglossaryentry{team}{
  name=team,
  description={A group of entities}
}
\newglossaryentry{turn}{
  name=turn,
  description={Consists of each member of both \glspl{team} of a \gls{battle} making a move}
}
\newglossaryentry{entity}{
  name=entity,
  plural=entities,
  description={A \gls{player} or \acrfull{npc}}
}
\newglossaryentry{player}{
  name=player,
  description={One who plays the game. A character controlled by a human}
}
\newglossaryentry{enemy}{
  name=enemy,
  plural=enemies,
  description={An entity of the opposing team}
}
\newglossaryentry{ally}{
  name=ally,
  plural=allies,
  description={An entity of the same team}
}
\newglossaryentry{boss}{
  name=boss,
  plural=bosses,
  description={A major \gls{enemy}}
}
\newglossaryentry{school}{
  name=school,
  description={An entity class}
}
\newglossaryentry{hp}{
  name=health point,
  description={A measure of health. An \gls{entity} is considered \gls{defeat}ed when their health points reaches zero}
}
\newglossaryentry{mana}{
  name=mana,
  description={A resource expended by players in PvE combat at the same rate as \glspl{point}}
}
\newglossaryentry{pip}{
  name=pip,
  description={A resource used to cast spells. Can either be a normal pip or power pip}
}
\newglossaryentry{point}{
  name=point,
  description={A resource supplied by pips; in order to cast a spell, an entity must have at least as many of this as the rank of the spell}
}
\newglossaryentry{mastery}{
  name=mastery,
  description={The ability to use power pips as if they gave two points for a certain school}
}
\newglossaryentry{charm}{
  name=charm,
  description={A hanging effect that affects the target's next outgoing spell that activates it. When activated, it is removed from its target},
}
\newglossaryentry{ward}{
  name=ward,
  description={A hanging effect that affects the target's next incoming spell that activates it. When activated, it is removed from its target},
}
\newglossaryentry{aura}{
  name=aura,
  description={A hanging effect that can be used multiple times but expires after a certain number of turns},
}
\newglossaryentry{global}{
  name=global,
  description={An effect that affects all members of both \glspl{team} of a \gls{battle}},
}
\newglossaryentry{defeat}{
  name=defeat,
  description={To deplete the \glspl{hp} of an \gls{entity}, making them unable to act until revived},
}
\newglossaryentry{card}{
  name=card,
  description={Also \emph{spell}. A move that an entity may \gls{plan} in a turn},
}
\newglossaryentry{plan}{
  name=plan,
  description={To intend to cast a \gls{card} during the planning phase to be casted later during the turn},
}
\newglossaryentry{pass}{
  name=pass,
  description={To refrain from planning a spell},
}
\newglossaryentry{deck}{
  name=deck,
  description={A collection of \glspl{card} prepared before battle},
}
\newglossaryentry{hand}{
  name=hand,
  description={A bag of \glspl{card} that a player may currently use in a given \gls{turn}},
}
\newglossaryentry{discard}{
  name=discard,
  description={To move a \gls{card} from one's hand to the \gls{discardpile}},
}
\newglossaryentry{discardpile}{
  name=discard pile,
  description={A place where used cards are stored. These cards may be reshuffled by a special spell},
}
\newglossaryentry{rank}{
  name=rank,
  description={The number of \glspl{point} needed to cast a spell. Also refers to \gls{pvprank}},
}
\newglossaryentry{pvprank}{
  name=PvP rank,
  description={A score that reflects how skilled a player is in \acrfull{pvp} combat},
}
\newglossaryentry{accuracy}{
  name=accuracy,
  description={The chance for a spell to not \gls{fizzle}},
}
\newglossaryentry{fizzle}{
  name=fizzle,
  description={To fail to cast a planned spell},
}
\newglossaryentry{effect}{
  name=effect,
  description={What a \gls{card} does},
}
\newglossaryentry{step}{
  name=step,
  description={One of the elements of the \gls{effect} of a spell},
}
\newglossaryentry{damage}{
  name=damage,
  description={The deduction of \glspl{hp} from a target},
}
\newglossaryentry{healing}{
  name=healing,
  description={The addition of \glspl{hp} to a (possibly \gls{defeat}ed) target, up to their maximum \glspl{hp}},
}
\newglossaryentry{pact}{
  name=pact,
  description={Represents something that happens in battle. For instance, `deal 400 -- 430 fire damage to one enemy' is a step, but `Uruwi deals 416 fire damage to 38tacocat83' is a pact},
}
\newglossaryentry{identifier}{
  name=effect identifier,
  description={A value taken by a charm or ward in order to prevent activating two copies of the same charm on one spell, or two copies of the same ward on the same pact},
}
\newglossaryentry{equipment}{
  name=equipment,
  description={The set of items worn by the \gls{player} to grant them boosts in their stats},
}
\newglossaryentry{assets}{
  name=assets,
  description={The files that are not part of the engine; these are downloaded by the client when it connects to a server. These include, but are not limited to maps, images, spell data and scripts},
}
\newglossaryentry{stun}{
  name=stun,
  description={To cause the target to be unable to move for a certain number of turns (usually one). Also the effect of doing so},
}
\newglossaryentry{level}{
  name=level,
  description={A property of a \gls{player} that affects many things such as maximum health and mana},
}
\newglossaryentry{pet}{
  name=pet,
  description={A piece of \gls{equipment} that can be trained to manifest \emph{talents} that give benefits to the player, as well as bred with other pets},
}
\newglossaryentry{enchantment}{
  name=enchantment,
  description={A \gls{card} that is not cast directly but rather is used on a card of the appropriate type to enhance its effects},
}
\newglossaryentry{lost}{
  name=lost,
  description={When referring to a card, not able to be reshuffled back into the deck for the remainder of the battle},
}
\newglossaryentry{dispel}{
  name=dispel,
  description={A \gls{charm} that causes the recipient to fizzle their next spell of a certain school and consume the pips that would have been used for that spell at the start of their next turn},
}
\newglossaryentry{blade}{
  name=blade,
  description={A \gls{charm} with a positive effect on its target, especially one that increases the damage of an attack spell},
}
\newglossaryentry{offschool}{
  name=off-school,
  description={Of a different school than the caster, when said of spells},
}
\newglossaryentry{cheat}{
  name=cheat,
  description={An ability of an \gls{enemy} to do something that is usually disallowed by the game mechanics, usually in a predictable manner},
}
\newglossaryentry{quest}{
  name=quest,
  description={A series of \glspl{objective} for the player to complete in exchange for currency, items, experience or access to other areas},
}
\newglossaryentry{objective}{
  name=objective,
  description={An element of a \gls{quest}},
}
\newglossaryentry{inventory}{
  name=inventory,
  description={The items held by a \gls{player}},
}
\newacronym{npc}{NPC}{non-player character}
\newglossaryentry{npcg}{
  name=non-player character,
  description={A character in the game that is not controlled by a human. In the context of combat, such a character that is participating in a battle},
}
\newacronym{pve}{PvE}{player-versus-enemy}
\newglossaryentry{pveg}{
  name=player-versus-enemy,
  description={Refers to combat between a team of players and a team of \gls{npc}s},
}
\newacronym{pvp}{PvP}{player-versus-player}
\newglossaryentry{pvpg}{
  name=player-versus-player,
  description={Refers to combat between a team of players and another team of players},
}

\title{x801tr02 Redux}
\author{uruwi}

\begin{document}

\pagecolor{Rhodamine!15}

\maketitle

\trsummary

\tableofcontents

\section{Introduction}

The original C++ codebase for Experiment801 is in a sorry state; even the AGC website states:\footnote{\url{http://nagakawa.gitlab.io/faq/\#entry3}}

\begin{quotation}
  x801 is currently in hiatus. The codebase is riddled with security issues and possibly concurrency bugs, and it's probably quite painful to work on. If there's enough interest, I might revive it from scratch.
\end{quotation}

Some code quality issues in the codebase:

\begin{itemize}
  \item Client performance was less than stellar, even though the game's visuals were extremely simple at that time; this might have to do with using an extremely large texture for terrain tiles
  \item Use of an in-house OpenGL wrapper; ideally, we'd prefer something off the shelf
  \item Excessive use of breadcrumb pointers
  \item Failure to check bad input, especially over the network
  \item \texttt{Server} and \texttt{Client} did too much stuff, as did \texttt{GameState} and \texttt{ClientGameState}
  \item Excessive use of exceptions
\end{itemize}

In general, the requirements for x801 were ill-specified beforehand. If we are to avoid the same issues as before, we must clearly list what x801 should have.

\newcommand{\rationale}[1]{\textit{Rationale:} #1}

\chapter{Game design}

\section{General requirements}

\emph{NB: any statements about x801 are our plans. Don't assume that they're actually set in silicon.}

Experiment801 (x801) is intended to be a multiplayer RPG with Wizard101-like combat mechanics. Of course, this does not mean that we need to implement everything the same way as Wizard101 (w101).

Unlike w101, x801 is free (as in speech). Anyone can read the source code and modify the engine or the \gls{assets}.

Ideally, it should be straightforward to run a small server for the game, while being able to scale to thousands of concurrent players at the same time. The server program should be relatively efficient with resources. \rationale{Simple server setup encourages more people to modify the assets. Scalability helps the community grow.}

x801 should be free of concurrency or security problems. Network traffic should be encrypted. \rationale{Trivial.}

It should be relatively straightforward for people to add content to the game assets. Needless to say, this requirement restricts the game's graphical impressiveness. \rationale{Encourage modification. Also, I don't have any 3D modelling experience or such.}

The x801 client should run on Windows and GNU/Linux at the least; the server should run on the same platforms. \rationale{Wizard101 runs on Windows, so we want current or former w101 players to be able to play x801 on that operating system. GNU/Linux so running a propietary OS is not needed to play.}

The client should be able to download the required assets automatically.

\section{Accounts}

Each player has one (or possibly) more accounts. An account has a username and a (hashed) password and is associated with one player character. (Wizard101 allows six characters per account, but we have no plans to support the likes thereof.)

A server manages its own set of accounts; a player would have to use a different account to play on server B than on server A.

From here on, we will use \emph{account}, \emph{player} and \emph{player character} interchangeably.

\section{Combat}

Combat works much like in Wizard101:

\begin{itemize}
  \item An \gls{entity} is a \gls{player} or an \acrfull{npc}. Each entity has current and maximum \glspl{hp} and \glspl{pip}, as well as zero or more active \glspl{charm} and \glspl{ward}. (Wizard101 also has \glspl{aura}; we might get to those later.)
  \item \Glspl{pip} are either \emph{normal pips} or \emph{power pips}. Normal pips always count as one \gls{point}. Power pips count as two points each if the caster has \gls{mastery} of the spell's school; otherwise, they count as one. (In w101, this is true if the caster's \gls{school} is the same as the spell's, but in x801, all schools master `Top' as well.)
  \item A \gls{battle} has two \glspl{team} composed of up to $N$ entities each. (In Wizard101, $N = 4$.) The objective of a team is to \gls{defeat}, or deplete the health points, of all members of the opposing team. A battle also has an optional active \gls{global} that provides effects to all entities in the battle.
  \item At the beginning of each \gls{turn}, each entity gains one pip, either normal or power, depending on their chances of getting a power pip.
  \item Players are dealt a number of \glspl{card} (also called \emph{spells}) from their \glspl{deck} to their \glspl{hand}. A player will always have $M$ (7 in w101) cards in their hand at the start of a \gls{turn}, unless there are not enough cards in their deck. A player can \gls{discard} (send to the \gls{discardpile}) some or all of their cards). They can then \gls{plan} a spell for that turn or \gls{pass} (refrain from planning any spell), as long as they are not defeated.
  \item NPCs use their turns (again, either planning a spell or passing) in some other manner.
  \item Each card has a name, a \gls{rank}, an \gls{accuracy}, a \gls{school} and an \gls{effect}.
  \begin{itemize}
    \item The rank of a spell is the number of pips needed for an entity to cast it. That number of pips are taken from the entity if the spell succeeds. (In w101, power pips are taken first if they count as two pips, and normal pips otherwise, when there is one pip left to take, normal pips are preferred over power pips.)
    \item The accuracy of a spell is the base chance for it to not \gls{fizzle}. When a spell fizzles, it has no effect. The chance for a spell to succeed can be modified by equipment. Whether a spell succeeds or not, it is sent to the discard pile.
    \item The effect of a spell consists of one or more \glspl{step}. Types of steps include, but are not limited to:
    \begin{itemize}
      \item Dealing \gls{damage} to, or taking health points from, one or all members of the opposing team of the caster (hereafter called an \gls{enemy}).
      \item \Gls{healing}, or restoring health points to, one or all members of the caster's team (hereafter called an \glspl{ally}).
      \item Placing a charm or ward on one or all \glspl{enemy}, or one or all \glspl{ally}.
      \item Reshuffling the discard pile back into the deck, making discarded cards available for use again.
      \item Placing a global in a battle.
    \end{itemize}
  \end{itemize}
  \item When all players have used their turns, each entity casts the spell they have planned (if present) in some manner (w101 chooses a team to go first for the battle then goes through each entity in order).
  \item When a spell is cast, steps are converted into \glspl{pact}, which represent something that happens in a battle. For instance, `deal 400 -- 430 fire damage to one \gls{enemy}' is a step, but `Uruwi deals 416 fire damage to 38tacocat83' is a pact.
  \item A charm affects the potency of one or more pacts that result from a spell from the entity with the charm. Charms can be activated before an entity attempts a spell (e.g.~accuracy charms) or when a specific kind of step is encountered. If a charm is activated, then it applies to all steps of a relevant type in a spell; in other words, if an entity had a charm that added 25\% damage and casts a spell with the effect `deal 200 fire damage, then 300 fire damage', then the charm would increase both hits by 25\%.
  \item A ward affects the potency of one pact that results from a spell toward the entity with the ward. If a ward is activated, then it applies to only one step of a relevant type in a spell; in other words, if entity A had a ward that added 25\% damage and entity B casted on A a spell with the effect `deal 200 fire damage, then 300 fire damage', then the ward would increase only the first hit by 25\%.
  \item When a charm or ward is activated, it is removed from the entity that had it.
  \item Each charm and ward has an \gls{identifier}, such that two charms of the same identifier on the same player are never activated in response to the same spell, and two wards of the same identifier on the same player are never activated in response to the same pact.
  \item When a player is defeated, they are unable to use their turns until their health points are restored by some later pact. When an NPC is defeated, they are removed from the battle altogether.
  \item In \acrfull{pve} combat, players have an additional resource called \gls{mana} that is expended when casting a spell, 1 mana per pip used. Naturally, if a player has less mana than the rank of a spell, they are unable to cast that spell. In w101, this resource is not used in \acrfull{pvp} battles, but having mana be used in such battles might have interesting implications.
\end{itemize}

Unlike in Wizard101 where damage is capped to 1,000,000, damage in x801 is limited only by the resources available to the server and clients (or perhaps a configurable limit to the number of bytes used to avoid DoS attacks). \rationale{Seeing how much damage can be dealt in one hit is a fun activity that the damage cap restricts.}

The mechanics should also be changed to reduce the extreme first-turn advantage in w101. The most obvious solution is to invoke each team's planning phase separately. \rationale{This is a major source of frustration for w101 players, especially in \acrshort{pvp}.}

There will be absolutely no critical system in x801. \rationale{The critical system in w101 made later fights frustrating while providing little benefit to \acrshort{pve} players.}

In the future, entities could have multiple health bars; when one bar is depleted on an entity, no more bars on that entity can be depleted until the next turn. This will likely be used only by \acrshort{npc} \glspl{enemy}, but let's not rule out player use.

\subsection{Equipment}

The classes of \gls{equipment} should be the same as in w101: a player can equip one item from each of the following: \emph{hats}, \emph{robes}, \emph{boots}, \emph{wands}, \emph{athames}, \emph{rings}, \emph{amulets}, \emph{decks} and \emph{pets}. \rationale{There isn't really a good reason to change this, other than to possibly avoid complaints from KI.}

(However, it should be possible to change this by modifying only the \gls{assets}.)

Such equipment can increase the following statistics of the player:

\begin{itemize}
  \item their maximum number of \gls{hp} or \gls{mana}
  \item bonuses to outgoing \gls{damage} for each \gls{school}
  \item resistances to incoming \gls{damage} for each \gls{school}
  \item bonuses to \gls{accuracy} for each \gls{school}
  \item their chance of getting a power \gls{pip}
  \item bonuses to outgoing or incoming \gls{healing}
  \item bonus to the chance of resisting an incoming \gls{stun} or that of succeeding on a stun against an \gls{enemy}
\end{itemize}

Equipment can also have \gls{level} or \gls{school} restrictions.

w101 displays attack, resistance and accuracy bonuses in whole percentages. x801 should be more granular and display these values to one-tenth of a per cent. Such values could be displayed either as `+7.1\% (stat)' or `+71 (stat)', though if the idea below is adopted, the latter notation would be less confusing.

In addition, there could be percentage bonuses to attack or resistance bonuses; if a player has 150 fire ATK then wears an equipment that gives `+9\% fire ATK', then the player will have 163 fire ATK afterwards (rounding down). The bonuses should be additive between equipment of the same level requirement but multiplicative between equipment of different level requirements. \rationale{Encourage wearing e.g.~a mix of level 58 and 56 gear instead of only level 58 equipment.}

In w101, incoming damage is reduced by the appropriate resistance value according to the formula $d = d_0 (1 - r)$, where $d_0$ is the damage before taking resistance into account, $r$ is the resistance value in whole units (e.g.~50\% is expressed as $0.5$), and $d$ is the damage after the adjustment. This provides augmenting returns: going from 80\% to 90\% resistance is more of a change than going from 0\% to 10\%. w101 had to add an `armour piercing' statistic to prevent resistance from being overpowered.

x801 should instead adjust the damage acoording to the formula $d = d_0 / (1 + r)$. That is, a player with 100\% resistance will survive twice as long as a player with none at all, and someone with 200\% resistance will survive three times as long. There is a linear relationship between resistance and how long it takes to be defeated.

\subsubsection{Pets}

\Glspl{pet} should work roughly as in w101: they have a number of \emph{talents}, a subset of which will be manifested by training; breeding two pets produces a pet with some talents from one and some from the other. However, the details might be different.

\subsection{Cards}

We explained \gls{card} briefly when explaining the combat mechanics. In this section, we cover specific cards, as well as \gls{deck} building.

\Glspl{enchantment} are not cast directly; rather, they can be used on a card of the appropriate type to enhance its effects. This discards both the enchantment and the card it was used on; when an enchanted card is used, it is \gls{lost}, or disappears altogether for the remainder of the battle, as w101 does currently.

Some cards also have a chance of being lost when used, rather than landing in the discard pile. This can, for instance, be used to prevent a player from reshuffling their deck infinitely.

\Glspl{dispel} are charms that cause the recipient to fizzle their next spell of a certain school; in addition, the pips that would have been used for that spell are deducted at the start of the next turn. In order to reduce the effectiveness of dispel spam, all dispel cards will be of the `Bottom' school.

In w101, most cards are acquired by \emph{training} spells. A player can train spells of their school for free but spends \emph{training points} for other spells. Some spells are acquired through quests that are restricted to one school. Once a spell is trained, as many copies of that spell can be placed in a deck as the deck allows. Cards can also be granted from equipment (in which case they are added to a separate section of the deck). Furthermore, \emph{treasure cards} can be placed in the \emph{sideboard}; once manually drawn in battle and successfully casted, they permanently vanish.

This is not the only approach; another would be to have each card be good for one copy in a deck. If this approach is taken, then it might be useful to allow a card to be shared between multiple decks, since only one deck is used at a time anyway. In addition, since many useful \gls{offschool} spells are of low \gls{rank}, some kind of training mechanic should be in place.

Cards will also have \emph{animations} that are shown to the client when cast. As detailed in x801tr01, an animation is a script that takes a list of pacts and shows effects on the screen. The server also uses animation scripts to calculate how much time an animation will take.

\subsubsection{Other card changes}

All \gls{school} single \glspl{blade} are +35\%, instead of varying by school as in w101.

Spells that cast multiple \glspl{charm} or \glspl{ward} of different schools do so in a random order.

\Gls{healing} spells restore less health than in w101.

\subsection{Schools}

In short, \glspl{school} are w101's term for \gls{player} (and \gls{enemy}) classes. A player's school affects the spells they can learn, the spells they can use power pips on, and the equipment they are free to wear.

x801's schools are different from w101's:

\begin{table}[h]
  \caption{Schools in x801 (tentative).}
  \centering
  \begin{tabular}{lll}
    School & Term for user & Specialty \\
    \hline
    Fire & Pyromancer & damage over time \\
    Ice & Thaumaturge & defence \\
    Lightning & Diviner & raw damage \\
    Water & ??? & manipulation and support \\
    Earth & ??? & debuffs, minions \\
    Wind & Mistral\footnote{Suggested by /u/SpaceEV.} & multi-hit attacks \\
    Light & Luminary & healing \\
    Darkness & Tenebromancer & drain attacks \\
  \end{tabular}
\end{table}

\begin{table}[h]
  \caption{Attributes of schools (tentative).}
  \centering
  \begin{tabular}{lllr}
    School & Health & Damage & Accuracy \\
    \hline
    Fire & 6th & 2nd & 75\% \\
    Ice & 1st & 7th & 85\% \\
    Lightning & 8th & 1st & 70\% \\
    Water & 2nd & 4th & 80\% \\
    Earth & 5th & 3rd & 75\% \\
    Wind & 7th & 8th & 90\% \\
    Light & 3rd & 6th & 80\% \\
    Darkness & 4th & 5th & 85\% \\
  \end{tabular}
\end{table}

In addition to these eight schools, there is the `Top' school, which all players master, and the `Bottom' school, which no player masters.

Of course, a content modder should be able to add or remove schools by modifying only the \gls{assets}.

\subsection{Enemies}

In w101, some \glspl{boss} have \glspl{cheat} that automatically cast a spell when a trigger is activated (e.g.~every 4 turns, or when the player heals). Such bosses became common only in the second story arc. We plan to introduce such bosses earlier in the game -- perhaps in the first world.

\subsection{Player-versus-player (PvP) combat}

Any decision related to combat should prioritise its impact on \acrfull{pvp} combat. \rationale{\acrshort{pvp} is popular among w101 players; most w101 YouTubers upload PvP-related videos. After all, PvP combat is arguably more interesting than \acrshort{pve}.}

Mechanics -- especially spells -- that tend to make \glspl{match} excessively long or short should be avoided.

\subsubsection{Matchmaking}

In 1v1 \glspl{match}, the matchmaking system should refuse to \gls{match} two players that have matched against each other within some amount of time. \rationale{Make `boosting' or `setting' harder, and reduce frustration caused by repeatedly losing against the same player.}

Similar restrictions should be put on larger battles, though exactly how is unknown.

When a (1v1) \gls{match} ends in w101, the winner is awarded 16 \gls{pvprank} and the loser has 16 points deducted from their rank. This causes frustration when a player is matched against someone else with a much higher rank. Instead, the rank bonus or penalty should be adjusted depending on the difference in rank between the winner and the loser.

\subsection{Timing requirements}

At most 1 second between clicking on a \gls{card} and having the choice show to \glspl{ally} and the server, on a good connection.

The delay for discarding cards (and optionally drawing TCs) should be too short to notice.

\section{Navigation}

Due to the difficulty of producing 3D \gls{assets}, x801 most likely will have a top-down perspective instead of a first-person one.

Wizard101 splits its world into discrete areas, and most actions are visible only to players in the same area. This gives the ability to assign each area its own thread, at the cost of some immersion.

Another alternative is to have one big map, but this model is nontrivial to parallelise. It is also likely that the world is hundreds or thousands of kilometres long canonically, but such distances are infeasible to travel in-game.

In short, while the `one-big-map' approach is more difficult than the `many-areas' approach, it is an option worth investigating.

\subsection{Quests}

A \gls{quest} consists of:

\begin{itemize}
  \item Its name. This should be unique to avoid confusion, but for efficiency reasons, this will probably not be the primary way of referring to a quest.
  \item An integer that uniquely identifies this quest. Once a new quest is added to the \gls{assets}, it bears the same ID regardless of future content updates.
  \item A list of \glspl{objective}, each of which can be one of the following:
  \begin{itemize}
    \item interacting with a \emph{point of interest}
    \item stepping into a certain region
    \item defeating one or more \glspl{enemy} of one or more given species, possibly with a success rate less than 1
    \item interacting with one or more instances of a \emph{repeatable point of interest} -- these have multiple instances; they are consumed when interacted with but soon replenish
  \end{itemize}
  Objectives also have the following fields:
  \begin{itemize}
    \item a textual description of the objective
    \item dialogue triggered upon completing the objective
  \end{itemize}
  \item A list of \emph{groups} of objectives. Objectives within the same group can be completed in any order. All objectives within a group must occupy a contiguous block.
  \item The rewards for completing the quest.
\end{itemize}

Quests are connected to each other in a directed acyclic graph; in order to be able to start a quest, all of its predecessors must be completed. In addition, there is only one quest that can lack a predecessor: the \emph{starting quest}.

(TODO: How are instance quests implemented?)

For each player, the following quest-related data are stored:

\begin{itemize}
  \item The set of completed quests.
  \item For each quest that the player is completing:
  \begin{itemize}
    \item The current objective group number.
    \item The progress on each objective within the group.
  \end{itemize}
\end{itemize}

\subsection{Fast travel}

Wizard101 has buttons to teleport to the commons area of the current world, as well as to the player's home. It also allows the player to leave a mark (at the cost of some \gls{mana}), to which they can teleport back once.

It is probably sensible to have the same options in x801, although additional marks could be given on completing certain storyline \glspl{quest}.

\subsection{Timing}

The delay between when a player presses a key and when they see their character move on their screen should be too short to notice. The delay between when a player presses a key and when other players see the character move should be at most 1 second on a good connection.

\section{Inventory}

Each player has an \gls{inventory}, which consists of:

\begin{itemize}
  \item A number of equipment (and housing) items, up to a certain limit. These items are not stackable; 23 copies of the same item will take up 23 slots.
  \item A number of (spell) cards, up to a certain limit. These are displayed as if they are stackable, but 23 copies of the same card still occupy 23 slots.
  \item In w101, reagents and pet snacks have unlimited slots.
  \item Possibly other types of items, depending on future game mechanics. It should be possible to add extra sections to the inventory via content modification alone.
\end{itemize}

\subsection{Implementation}

An \emph{inventory section} is said to have the following attributes:

\begin{itemize}
  \item A name, of course.
  \item The maximum number of items allowed.
  \item A list of subsections of this section.
  \item Whether items in this section have extended properties.
\end{itemize}

\section{Player interaction}

\subsection{Chat}

A player can send a free-form message (up to some length) using the chat box. \emph{Local messages} are visible to all other players on the same area. \emph{Private messages} are sent to a specific user, to whom the message is visible.

We could add support for chat filtering later in development, but this isn't much of a priority.

\subsubsection{Timing}

At most 2 seconds between when a player presses Enter and when other players see the message. Of course, players should see their own messages without noticeable delay.

\subsection{Trading}

Direct player-to-player trading works like treasure card trading in Wizard101, except that it works with all items by default. Certain categories of items can be made untradeable by configuration, however, and individual items can be marked untradeable.

Players should also be able to start shops. Again, items or item categories can be blocked from being sold.

\chapter{Communication}

\section{Filehosts}

A \emph{filehost} is a server dedicated to hosting game data. This activity is split off from the game server itself to avoid redundancy with multiple servers using the same game data. If a client connected to five servers that used the same game data, then this approach saves having to download the same data five times.

A filehost also serves a file that provides either a hash or a timestamp of other files, so clients can download only what has changed.

It could be nice to ascertain which files are relevant to the client and which are relevant to the server, such that clients and servers can download whichever files they need.

\section{Gatekeepers}

When a player connects to a game `server', they are actually connecting to a \emph{gatekeeper}, which is a service (probably through HTTP) that sends the address to the filehost, as well as a list of available \emph{shards}. Any public keys to shards are given by the gatekeeper as well.

When a client connects to a gatekeeper, it updates the game data from the filehost. Then it tries to log into a random available shard until it succeeds or fails for a reason other than a full shard.

Alternatively, the gatekeeper can connect the client to a random shard, optionally taking the client's preference.

The default gatekeeper will be relatively simple. It is expected that those who want to scale their servers can simply replace the gatekeeper with their own version.

\section{Shards}

Shards perform actions related to the game itself, and each shard is a separate instance of the game running. Small servers will have only one shard; larger ones might need more.

A player should not be able to join multiple shards at the same time. One way to enforce this rule is to let the gatekeeper choose a shard and notify the shard of an incoming connection. The gatekeeper then remembers which shard the player joined; when the player connects to the gatekeeper again, the gatekeeper tells the remembered shard to disconnect the player. There might be other approaches to this problem.

In addition, shards should sync their data between each other, and some features will have to work between multiple shards (such as private messages or rate limits).

(Perhaps there could be a shard for each area or group of several areas, in order to guarantee that no area will be too crowded, but this requires the gatekeeper to manage shards dynamically. Most large servers will probably want to do this anyway.)

\section{The database}

The database is used for obvious purposes.

It sends and receives packets in an abstract format (rather than raw SQL or such), allowing for different implementations that employ a different DBMS or use a cache.

\section{Security}

Only the gatekeeper should be allowed to accept connections from any address.

\begin{itemize}
  \item Shards should connect to only the gatekeeper at first. They should accept a connection from a client only once its gatekeeper tells it to do so.
  \item Databases should connect only to the gatekeeper at first. They should accept a connection from a shard only once its gatekeeper tells it to do so.
\end{itemize}

In addition, all network traffic should be encrypted as to prevent intercepters from being able to read it.

\chapter{Technical notes}

\section{Code layout}

The codebase should separate `platform-dependent' code (\texttt{pd/}) from `platform-independent' code (\texttt{pi/}). The former interfaces with APIs that are likely to be replaced with another (e.g.~networking, graphics, databases) and the latter contains the actual game logic. This separation also makes it easier to log and replay nondeterministic function calls for easier debugging.

The actual game logic is confined to a finite state machine. This FSM is deterministic -- given the same series of inputs (in some abstract format), the outputs will be the same. \rationale{Again, easier debugging.}

\chapter{Assets}

\Gls{assets} are files that hold the content of the game -- that is, those that are not part of the engine. They are downloaded by the client when it connects to a server.

There should be safeguards against making a modification to the assets that breaks save files. In other words, the asset-building script should refer to the previously-built asset binaries to check that, for instance, no enemies or quests are being removed.

The asset-building process should be possible on both Windows and GNU/Linux\footnote{The old codebase used a makefile for this, which would have been a roadblock to this goal.}.

\clearpage
 
\printglossary[type=\acronymtype]

\printglossary

\glsaddallunused

\end{document}